﻿shr.defineClass("shr.compensation.CmpItemMappingList", shr.framework.List, {
	editViewDisable: true,
	initalizeDOM: function(){
		shr.compensation.CmpItemMappingList.superClass.initalizeDOM.call(this);		
	},
	
	//获取EASHR薪酬项目
	getOutCmpItemAction: function() {
		var _self = this;
		var msg = "重新获取EASHR薪酬项目将把当前的数据自动存档，可在下载历史匹配数据中下载查看，现有的数据将全部清空，你确认重新获取？";
		var hasMatch = _self.checkHasMatch();
		if(hasMatch) {
			shr.showConfirm(msg, function() {
				_self.getCmpItemData(true);
			});
		} else {
			_self.getCmpItemData(false);
		}
	},
	
	//校验是否有已经匹配映射的数据
	checkHasMatch: function() {
		var _self = this;
		var hasMatch = false;
		_self.remoteCall({
			method: "checkHasMatch",
			async: false,
			param: {},
			success: function(res) {
				if(res) {
					hasMatch = res.hasMatch == "Y" ? true : false;
				}
			}
		});
		return hasMatch;
	},	
	
	/**
	 * 获取eas端薪酬项目数据
	 * @param isBack true:需要备份  false:不需要备份
	 */
	getCmpItemData: function(isBack) {
		var _self = this;
		_self.remoteCall({
			method: "getOutCmpItem",
			param: {isBack: isBack},
			success: function(res) {
				_self.queryGrid();
			}
		});
	},
	
	//自动匹配
	autoMatchAction: function() {
		var _self = this;
		$.cmpUpGrade.showMsg("正在进行自动匹配，请稍后！");
		var msg = "";
		_self.remoteCall({
			method: "autoMatch",
			param: {},
			success: function(res) {
				_self.queryGrid();
				if (res && res != null) {
					var hasMatch = res.isAllMatch;
					if ("Y" == hasMatch) {
						msg = "全部数据都匹配上了，请导出后核对，可在导出文件中手工调整匹配关系后，上传文件导入！";
					} else {
						msg = "有数据没有匹配上，请导出查看，在导出文件中手工匹配后，上传文件导入！";
					}
					$.cmpUpGrade.showMsg(msg);
				}
			}
		});
	},
	
	//下载历史匹配数据
	downloadHisAction: function() {
		var _self = this, $dialog = $("#templateDialog"), $body = $(document.body);		
		if ($dialog.size() != 0) {
			$("#templateDialog").remove();
		}
		$dialog = $("<div id='templateDialog' style='width:600px;'><table id='tempTab'></table></div>").appendTo($body);	
		var cols = [{name: "name", label: "最近映射模板", align: "center"}];
		var data = [];
		_self.remoteCall({
			method: "getHisMappingName",
			async: false,
			param: {},
			success: function(res) {
				var hisNames = res;
				for (var i = 0; i < hisNames.length; i++) {
					var tempName = {"name": hisNames[i]};
					data.push(tempName);
				}
			}
		});
		initTable("#tempTab", data, cols,{
			width:600,
			rownumbers : true,
			multiselect : false,
			onSelectRow : function(rowId, status, event){					
				var currentObj = $("#tempTab").jqGrid("getRowData", rowId);
				var currentName = currentObj.name;
				var option = {};
				option.type = "his";
				option.hisName = currentName;
				_self.downloadTempAction(option);
	    	}
	    });
		$("#jqgh_tempTab_name").css("text-align","center");
		showDialog("#templateDialog", "下载历史匹配数据", null);
	},
	
	importDataAction: function() {
		var _self = this;
		var title = "导入薪酬项目映射";
		var html = [], $dialog = $("#importDialog"), $body = $(document.body);		
		if($dialog.size() == 0) {
			$dialog = $("<div id='importDialog' style='padding-left: 12px;overflow-y: hidden;'></div>").appendTo($body);
		}
		// 初始化对话框
		html.push(importDivHtmlHead);
		html.push("<div class='import-title' style='margin-top: 15px;'>第1步. 上传数据文件</div>");
		html.push('');
		html.push("<div class='import-content'><div id='file_upload-button' class='uploadify-button ins-btn' style='height: 30px; line-height: 30px; width: 120px;'><span class='uploadify-button-text'>上传数据文件</span></div><p><input id='file_upload' name='file_upload' type='file' style='opacity: 0;position: absolute;cursor: pointer;margin-top: -32px;margin-left: 0px;height: 30px;line-height: 30px;width: 120px;'/></p><div id='uploadexcelfile'></div></div>");		
		
		html.push("<div class='import-title'>第2步. 校验数据有效性</div>");
		html.push("<div id='checkDiv' class='import-content'>");
		html.push("<div class='progress progress-striped active hide' style='width: 500px;'>");
		html.push("<div id='checkBar' class='bar' style='width: 0%;'></div></div>");
		html.push("<div class='result'>");
		html.push("</div></div>");
		
		html.push("<div class='import-title'>第3步. 导入数据</div>");
		html.push("<div id='importDiv' class='import-content'>");
		html.push("<div class='progress progress-striped active hide' style='width: 500px;'>");
		html.push("<div id='importBar' class='bar' style='width: 0%;'></div></div>");
		html.push("<div class='result'>");
		html.push("</div></div>");	
		showDialog("#importDialog", title, html.join(""), null, null, 550, "关闭");	
		var url = shr.getContextPath() + "/dynamic.do?handler=com.kingdee.shr.easupgrade.compensation.web.handler.CmpItemMappingListHandler&method=importData";
		url += "&" + getJSessionCookie();
		//由于uploadify在ie9上会报404错误  故使用jQuery插件
		$("#file_upload").fileupload({
            url : url,
            formData : {},
            asyn : false,
            dataType : "json",
			acceptFileTypes:  /(\.|\/)(xlsx)$/i,//限制文件类型
			maxNumberOfFiles : 1,//限制文件个数
			maxFileSize: 50000000,//限制文件大小50m
            start : function(e) {
                error_path = 'undefined';
		    	var $cBar = $("#checkBar"), $cp = $cBar.parent();
				$cp.hide();  $cp.prev().show();  $cBar.width(0).text("");
				var $iBar = $("#importBar"), $ip = $iBar.parent();
				$ip.hide();  $ip.prev().show();  $iBar.width(0).text("");
            },
			progressall: function (e, data) {
				var progress = parseInt(data.loaded / data.total * 100, 10);
                $( '#uploadexcelfile' ).append("<p class = 'attachment-loading'>文件正在上传，请稍后 .. <span class = 'progress'></span></p>");
                $( "#uploadexcelfile span.progress" ).html( progress+"%" );
			},
            add: function ( e,data ) {
				$( '#uploadexcelfile' ).empty();
                var fileType = _self._getFileTypeByName(data.originalFiles[0].name);
                if(data.originalFiles[0]['type'] && data.originalFiles[0]['type'].length && !(fileType == '.xlsx') ){
                    shr.showError({ message: '文件格式不对，修改一下吧。 ( 可以上传的格式 ：xlsx )'});
                    return;
                }
                if( data.originalFiles.length && data.originalFiles[0]['size'] && data.originalFiles[0]['size'] > 50*1024*1024 ){
                    shr.showError({ message: "文件大小超出限制，请上传小于50M的文件" });
                }
                else{
                    data.submit();
                }
            },   
            error: function(response) {
            	var result = response.responseText;
            	if (result && result != "") {
            		// 截取错误信息
            		var msg = result.substring(result.indexOf("summary")+10,result.indexOf("result")-3)
            		_self.showMsg(msg, "error");
            	}
            },
            done: function( e,data ) {
				$("#loadimg").css("display","none");
				$("#importDiv span").remove();
				var resultData = data.result;				
				if (resultData.result == 'success') {
					error_path = resultData.data.errorPath;
					if(undefined == error_path || error_path != ''){
						$("#checkDiv div.result").html("校验失败。请查看检查报告");
						var $iBar = $("#importBar"), $ip = $iBar.parent();
						$ip.show();  $ip.prev().show();  $iBar.width(500).text("");
						$("#checkDiv div.result").html("校验失败，请下载<a href='#' id='error_rpt' style='color:blue;'>检查报告</a>查看校验失败的数据，修改后重新导入。");
						_self.queryGrid();
					}else{
						$("#checkDiv div.result").html("校验成功。");
						var $iBar = $("#importBar"), $ip = $iBar.parent();
						$ip.show(); $ip.prev().show();  $iBar.width(500).text("");
						$("#importDiv div.result").html("导入成功。");	
						_self.queryGrid();
					}
				} else {
					$("#checkDiv div.result").html("校验成功。");
					$("#importDiv div.result").html("导入失败。");
					shr.showError({
						hideAfter: null,
						message: resultData.summary
					});					
				}
				$('#error_rpt').live('click', _self.downloadErrorRptAction);				           	
            }
        });				
		_self.addDownloadAction();
	},
	
	addDownloadAction:function() {
		var _self = this;
		$("#downloadTempuuid3").bind("click",function(){
			var option = {};
			option.type = "current";
			_self.downloadTempAction(option);
		})
	},	
	
	/**
	 * 下载导入模板
	 */
	downloadTempAction: function(option) {
		var _self = this;
		var postData=$("#grid").jqGrid("getGridParam","postData");
		var queryModel = '';
		var columns = postData.columnModel.split(",");
		for (var i = 0; i < columns.length; i++) {
		    var optionColumn = $("#grid").jqGrid("optionColumn",columns[i]);
		    var hidden = optionColumn.hidden,
		        label = optionColumn.label;
		    if(columns[i] != null && columns[i] != "") {
		    	queryModel += columns[i] + ","+hidden + ","+label + ";";
		    }
		}
		var param = {};
		$.extend(param, option);
		param.queryModel = queryModel;
		param.uipk = _self.uipk;
		param.method = "downloadTemplate";
		param.handler = "com.kingdee.shr.easupgrade.compensation.web.handler.CmpItemMappingListHandler";
//		var url = shr.getContextPath() + "/dynamic.do?handler=com.kingdee.shr.compensation.web.file.CalFileHandler&method=downloadTemplateWithPersons";
//		location.href = url + "&" + encodeURIComponent($.param(param));
		var url = shr.getContextPath() + shr.dynamicURL;
		shr.doAction({
			url: url,
			type: 'post', 
			data: param,
			success : function(response) {
				document.location.href = location.href = shr.getContextPath() + response;
			}
		});						
	},	
	
	//获取文件类型
	_getFileTypeByName : function(filename){
        var _self = this;
        var filename = filename.split(".");
        var fileType = "."+filename[ filename.length - 1 ];
        return fileType;    
    },		
	
	/**
	 * 下载检查报告
	 */
	downloadErrorRptAction: function() {
		if(error_path!=null && error_path!="" && error_path != "undefined"){		
			var param = {
			    handler :'com.kingdee.shr.easupgrade.compensation.web.handler.CmpItemMappingListHandler',
				method: 'downloadErrorReport',
				error_path: error_path ? error_path : ""
			}
			location.href = shr.getContextPath() + shr.dynamicURL + '?' + $.param(param);
		}
	}
	
});