﻿shr.defineClass("shr.easupgrade.CmpUpGradeProject", shr.framework.Edit, {
	editViewDisable: true,
	upGradeStatus: 0,//迁移状态  0表示还没有迁移  1表示正在迁移  2表示迁移完成或者异常中断
	delStatus: 0,//删除状态 0 表示还未删除完成  1表示删除完成
	initalizeDOM: function(){
		shr.easupgrade.CmpUpGradeProject.superClass.initalizeDOM.call(this);		
	},
	
	//进入数据库配置界面
	connectionConfAction: function() {
		this.go("com.kingdee.shr.easupgrade.compensation.app.UpGradeConnection.list");
	},
	
	//检查源数据库连接
	checkConnectionAction: function() {
		var _self = this;
		_self.remoteCall({
			method: "checkConnection",
			success: function(re) {
				if (re) {
					$.cmpUpGrade.showMsg("测试连接成功！");
					$("#connY").show();
					$("#connN").hide();
				} else {
					$.cmpUpGrade.showMsg("连接测试失败！请检查数据库IP地址、端口、用户名和密码等是否正确。", "error");
					$("#connY").hide();
					$("#connN").show();
				}
			}
		});
	},
	
	//进入薪酬项目匹配界面
	cmpItemMatchAction: function() {
		this.go("com.kingdee.shr.easupgrade.compensation.app.CmpItemMapping.list");
	},
	
	//进入薪酬方案匹配界面
	cmpSchemeMatchAction: function() {
		this.go("com.kingdee.shr.easupgrade.compensation.app.CalSchemeMapping.list");
	},
	
	//检查数据匹配情况
	checkMatchStateAction: function() { 
		var _self = this;
		_self.remoteCall({
			method: "checkMatchState",
			success: function(re) {
				if (re) {
					$.cmpUpGrade.showMsg(re);
					$("#matchAll").show();
					$("#notMatchAll").hide();
				}
			},
			error: function(re) {
				if (re) {
					var msg = re.responseText.substring(re.responseText.indexOf("summary")+10,re.responseText.indexOf("result")-3);
					$.cmpUpGrade.showMsg(msg,"error");
					$("#matchAll").hide();
					$("#notMatchAll").show();
				}
			}
		});
	},
	
	//开始迁移
	upGradeStartAction: function() {
		var _self = this;
		$("#cmpMsg").html('');
		$("#adjMsg").html('');
		var isUpGradeScheme = $("#schemeHisData").is(":checked");
		var isUpGradeAdj = $("#adjHisData").is(":checked");
		if (!isUpGradeScheme && !isUpGradeAdj) {
			$.cmpUpGrade.showMsg("请选择需要迁移的数据项！", "error");
			return;
		}
		_self.upGradeStatus = 1;
		var param = {
			scheme: isUpGradeScheme,
			adj: isUpGradeAdj
		};
		var message = "已有迁移数据，重新迁移需要先删除已迁移数据";
		_self.remoteCall({
			method: "checkHasUpGraded",
			param: param,
			success: function(re) {
				if ("Y" == re) {
					$.cmpUpGrade.showMsg(message);
				}
				_self.initUpGrade(param);
			}
		});
		
	},
	
	//初始化升级方法
	initUpGrade: function(param) {
		var _self = this;
		var flag = _self.checkInitData(param);
		if (!flag) {
			return;
		}
		if (param.scheme) {
			$("#schemeProgressbar").html("迁移初始化中，请稍等...");
		}
		if (param.adj) {
			$("#adjProgressbar").html("迁移初始化中，请稍等...");
		}
		_self.remoteCall({
			method: "initUpGrade",
			param: param,
			success: function(re) {
				$("#schemeProgressbar").html("");
				$("#adjProgressbar").html("");
				_self.getFinishedPer(param);
				_self.upGrade(param);
			}
		});	
	},
	
	//迁移之前校验数据库连接和数据匹配情况
	checkInitData: function(param) {
		var _self = this;
		var flag = true;
		var msg = "";
		_self.remoteCall({
			method: "checkInitData",
			param: param,
			async: false,
			success: function(re) {
				if (!re.connFlag) {
					msg = "请管理员在“数据升级及迁移->EAS HR数据迁移->EAS HR数据库配置”中设置源数据库信息并测试连接。"
					$("#connY").hide();
					$("#connN").show();
					$.cmpUpGrade.showMsg(msg,"error");
					flag = false;
					_self.upGradeStatus = 2;
					return;
				}
				if (!re.itemFlag) {
					msg = "存在未匹配的薪酬项目，请在“薪酬项目匹配”菜单中过滤未匹配的数据，手工导入！"
					$("#matchAll").hide();
					$("#notMatchAll").show();
					$.cmpUpGrade.showMsg(msg,"error");
					flag = false;
					_self.upGradeStatus =2;
					return;
				}
				if (param.scheme && !re.schemeFlag) {
					msg = "存在未匹配的薪酬方案，请在“薪酬方案匹配”菜单中过滤未匹配的数据，手工导入！";
					$("#matchAll").hide();
					$("#notMatchAll").show();
					$.cmpUpGrade.showMsg(msg,"error");
					_self.upGradeStatus =2;
					flag = false;
				}
			}
		});	
		return flag;
	},
	
	//真正执行迁移的方法
	upGrade: function(param) {
		var _self = this;
		_self.remoteCall({
			method: "upGrade",
			param: param,
			success: function(re) {
				_self.upGradeStatus = 2;
				if (re && !re.flag) {
					$.cmpUpGrade.showMsg(re.msg, "error");
				}
			}
		});
	},
	
	//获取迁移进度
	getFinishedPer: function(param) {
		var _self = this;
		var currentUpGradeStatus = _self.upGradeStatus;
		_self.remoteCall({
			method: "getFinishedPer",
			param: param,
			success: function(re) {
				var cmpPer = re.cmpPer;
				var adjPer = re.adjPer;
				var status = Number(re.status);
				if (param.scheme) {
					$("#schemeProgressbar").html("<div id='cmpProgress' style='height:100%;'></div>");
					$("#cmpProgress").progressbar({
						value: cmpPer,
						max: 100
					});
					if (cmpPer == 100) {
						$("#cmpMsg").html("<p>迁移完成</p>");
					}
				}
				if (param.adj) {
					$("#adjProgressbar").html("<div id='adjProgress' style='height:100%;'></div>");
					$("#adjProgress").progressbar({
						value: adjPer,
						max: 100
					});
					if (adjPer == 100) {
						$("#adjMsg").html("<p>迁移完成</p>");
					}
				}
				if (status == 0 && currentUpGradeStatus == 1) {
					setTimeout(_self.getFinishedPer(param), 1000);
				}
			}
		});
	},
	
	//删除已迁移数据
	delUpGradeDataAction: function() {
		var _self = this;
		_self.delStatus = 0;
		var isUpGradeScheme = $("#schemeHisData").is(":checked");
		var isUpGradeAdj = $("#adjHisData").is(":checked");
		if (!isUpGradeScheme && !isUpGradeAdj) {
			$.cmpUpGrade.showMsg("请选择需要删除的数据项！", "error");
			return;
		}
		if (1 == _self.upGradeStatus) {
			$.cmpUpGrade.showMsg("数据正在迁移中，不允许删除数据！", "error");
			return;
		}
		var param = {
			scheme: isUpGradeScheme,
			adj: isUpGradeAdj
		};
		var msg = "确认要删除已经迁移的数据吗？";
		shr.showConfirm(msg, function(){
			//删除中给予进度 由于删除较快  就不加进度情况   后续要加再打开
			var timerId= setInterval(function(){
					var obj = {};
					$.extend(obj, param);
					var currenTime = (new Date()).getTime();
					obj.myTime = parseInt(currenTime/1000);
					_self.getDelStatus(obj);
			}, 1000);
			$.extend(param, {timerId: timerId});
			_self.delData(param);
		});
		
	},
	
	//执行删除方法
	delData: function(param) {
		var _self = this;
		$("#cmpMsg").html('');
		$("#adjMsg").html('');
		$("#schemeProgressbar").html("");
		$("#adjProgressbar").html("");
		var delMsg = "<div id='del' style='color:blue;text-align:right;'><img src='"+ shr.getContextPath() +"/addon/shreasupgrade/web/image/apply.gif' />删除完成</div>";
		_self.remoteCall({
			method: "delUpGradeData",
			param: param,
			success: function(re) {
				clearInterval(param.timerId);
				_self.delStatus = 1;
				if (param.scheme) {
					$("#schemeProgressbar").html(delMsg);
				}
				if (param.adj) {
					$("#adjProgressbar").html(delMsg);
				}					
				$.cmpUpGrade.showMsg("删除成功！");
			}
		});
	},
	
	//获取删除状态   暂时不使用
	getDelStatus: function(param) {
		var _self = this;
		var dot = param.myTime % 3;
		var word = "";
		for (var i = 0; i <= dot; i++) {
			word += ".";
		}
		var deling = "<div style='color:blue;width:100%;line-height:14px;height:14px'>删除中"+ word +"</div>";
		_self.remoteCall({
			method: "getDelStatus",
			param: param,
			success: function(re) {
				if (re && _self.delStatus == 0) {
					if (param.scheme && re.scheme) {
						$("#schemeProgressbar").html(deling);
					}
					if (param.adj && re.adj) {
						$("#adjProgressbar").html(deling);
					}
					return;
				}
			}
			
		});
	},
	
	go: function(uipk) {
		this.reloadPage({
			uipk: uipk,
			inFrame: true
		});
	}
	
});

function downloadDesc() {
	var uipk = "com.kingdee.shr.easupgrade.compensation.app.CmpUpGradeProject.form";
	var url = shr.getContextPath() + '/dynamic.do?handler=com.kingdee.shr.easupgrade.compensation.web.handler.CmpUpGradeProjectHandler' +
			'&method=getDescPath&uipk=' + uipk;
	location.href = url;
}
