shr.defineClass("shr.emp.UpGradePersonList", shr.framework.List, {
	timeoutJob:null,
	upGradeResultPer:null,//每次的迁移结果
	initalizeDOM : function() {
		shr.emp.UpGradePersonList.superClass.initalizeDOM.call(this);	
		//初始化处理结果的框
		this.initResultDialog();
		//加入下载的框
		this.appendDownLoadIntro();
		//加入tabs
		this.appendListTabs();
		//重置面包屑
		this.resetBreadcrumb();
	},
	/**
	 *在职人员列表应该只显示在职人员且是主要任职的
	 */
	getCustomFilterItems: function() {
		var filter = "positionMember.isprimary =1";
		return filter;
	},
	//校验迁移
	upgradeAction:function(){
		var _self = this;
		var verifyResult;
		_self.remoteCall({
			type : "post",					
			showBlock : true,
			method : "verifyUpGrade",
			success : function(data){
				verifyResult = data;
				if(verifyResult.verifyPass==false){
					shr.showError({
						message: verifyResult.verifyPassMsg,
						hideAfter: 5
					});
				}else{
					shr.showConfirm(verifyResult.verifyPassMsg, function(){
						_self.doInitUpGrade();
					});
				}
			}
		});
	},
	//获取迁移时的初始值
	doInitUpGrade:function(){
		var _self = this;
		_self.remoteCall({
			type : "post",					
			showBlock : true,
			method : "initUpGrade",
			
			success : function(data){
				_self.showResultDialog();
				//真正执行迁移
				_self.doUpGrade();
				_self.getFinishedPer(data);
			}
		});
		
	},
	personNotInServiceListAction: function() {
	
	   var _self = this;
		this.reloadPage({
			uipk: 'com.kingdee.shr.easupgrade.emp.app.UpGradePersonNotInService.list',
			operateState: 'View'
		});
	},
	
	initResultDialog: function(){
		$("#resultDialog").hide();
	},

	showResultDialog:function(){
		var _self = this;
		var dialog = $("#resultDialog");
		dialog.dialog({
			autoOpen : false,
			show : "blind",
			width : 675,
			height : 400,
			title : "迁移结果",
			resizable : false,
			position : [ 'center', 'center' ],
			modal : true,
			buttons : [ {
				text : "结束",
				disabled : false,
				click : function(){	
					var flag = _self.validDialogCanClose();
					if(flag){
						dialog.dialog("close");	
					   _self.queryGrid();
					}else{
						shr.showError({
							message: "迁移正在进行中，禁止关闭",
							hideAfter: 5
						});
					}				
				}
			} ],
			close : function(event, ui){
				var flag = _self.validDialogCanClose();
				if(flag){
				   _self.queryGrid();
				}else{
					shr.showError({
						message: "迁移正在进行中，禁止关闭",
						hideAfter: 5
					});
				}
			},
			 //隐藏默认的关闭按钮
             open: function (event, ui) {
                 $(".ui-dialog-titlebar-close", $(this).parent()).hide();
             }
		});
		dialog.dialog("open");	
		$("#progressbar").progressbar({
			value : 0,
			max : 100
		});
		return;
	},
	validDialogCanClose:function(){
		var _self =this;
		var dialog = $("#resultDialog");
		if(_self.upGradeResultPer!=null){
			if(_self.upGradeResultPer.finishedPer>0&&_self.upGradeResultPer.finishedPer!=100&&_self.upGradeResultPer.processMessage==null){
				return false;
			}else{
				return true;
			}
		}
	},
	getFinishedPer:function(data){
		var _self = this;
		_self.setDialogResult(data);
		var result  = data.upGradeResult;
		if(!result.upGradeOver){
			var _self = this;
			_self.remoteCall({
				type : "post",
				method : "getFinishPer",
				async : false,
				showBlock : true,
				success : function(data){
					_self.timeoutJob =setTimeout(function(){
						_self.getFinishedPer(data);
					}, 500);
				}
			});
		}else{
			
		}
		
	},
	setDialogResult:function(data){
		var upGradeResult = data.upGradeResult;
		var _self = this;
		_self.upGradeResultPer = upGradeResult;
		$("#progressbar").progressbar({
			value : upGradeResult.finishedPer,
			max : 100
		});
		$("#in_total").html(upGradeResult.inTotal);
		$("#in_success_count").html(upGradeResult.inSuecessCount);
		$("#in_faild_count").html(upGradeResult.inFailCount);
		
		$("#notin_total").html(upGradeResult.notInToal);
		$("#notin_success_count").html(upGradeResult.notInSucessCount);
		$("#notin_faild_count").html(upGradeResult.notInFailCount);
		
		if(upGradeResult.processMessage==null||upGradeResult.processMessage==""){
		  $("#upGradeMessage").html("正在迁移，请稍等...");
		  $("#upGradeMessage").css({"color":"black","font-size":"18px"});
		}else if(upGradeResult.processMessage!=null){
		  $("#upGradeMessage").html(upGradeResult.processMessage);
		  $("#upGradeMessage").css({"color":"red","font-size":"18px"});
		}
		if(upGradeResult.finishedPer==100&&upGradeResult.upGradeOver==true){
		  $("#upGradeMessage").html("迁移已结束，请检查员工迁移状态");
		  $("#upGradeMessage").css({"color":"green","font-size":"18px"});
		  if(_self.timeoutJob){
			clearTimeout(_self.timeoutJob);
		  }
		  _self.remoteCall({
				type : "post",					
				showBlock : true,
				method : "getFinishPer",
				param : {"finished":"true"},
				success : function(data){
					
				}
			});
		}
	},
	doUpGrade:function(){
		var _self = this;
		_self.remoteCall({
			type : "post",					
			showBlock : true,
			method : "upGrade",
			success : function(){
			
			}
		});
	},
	recoverUpGradeAction:function(){
	var _self = this;
	_self.upGradeResultPer = null;
		_self.remoteCall({
			type : "post",					
			method : "recoverUpGrade",
			success : function(){
				shr.showInfo({message: "操作成功",
							hideAfter: 5});
				_self.queryGrid();			
			}
		});
	},
	onCellSelect:function(){
		return;//不需要编辑界面
	},
	appendDownLoadIntro:function(){
		$("#workAreaDiv .view_manager_header").append("<div id='downloadIntro'style='font-size:12px;color:blue;display:block;float:right;margin-right:40px'></div>");
		$("#downloadIntro").append("<a href='/shr/dynamic.do?handler=com.kingdee.shr.easupgrade.emp.web.handler.UpGradePersonListHandler&method=downloadUpgradeIntro'  target='_blank'>下载迁移说明</a>");
	},
	appendListTabs:function(){
		
		var tabs = shr.createObject(shr.emp.UpGradePersonListTabs);
		tabs.getListTab(this.uipk);
	},
	resetBreadcrumb:function(){
		var _self = this;
		var breadcrumbData = [
			/*{
				location: "top",
				name: "主页",
				url: "/shr/home.do"
			},*/
			{
				 name: "EASHR员工数据迁移",
				 url: window.location.href
			}
		]
		var breadcrumb = $('#breadcrumb').shrBreadcrumb();
		breadcrumb.shrBreadcrumb('clean');
		for(var i=0;i<breadcrumbData.length;i++){
			$('#breadcrumb').shrBreadcrumb('addItem',breadcrumbData[i]);
		}
	}
});